Skip to contentSkip to navigationSkip to topbar

Memory API (v1) - Traits endpoints


(information)

Legal information

Conversation Memory, including the APIs, may use artificial intelligence or machine learning technologies and is subject to the terms of the Predictive and Generative AI/ML Features Addendum(link takes you to an external page). For more details on AI usage and data, see the AI Nutrition Facts.

Conversation Memory is not a HIPAA Eligible Service or PCI compliant and should not be enabled in workflows that are subject to HIPAA or PCI.

Conversation Memory is not intended for use with sensitive information about individuals. Twilio does not control what information comes from conversation channels and relies on you to ensure the data in customer profiles aligns with our acceptable use policy. Twilio does have limited guardrails in the form of a prompt exclusion that is designed to provide a minimal screening against inclusion of GDPR special category data(link takes you to an external page). As a reminder our profile technology uses generative artificial intelligence. Because generative artificial intelligence can make mistakes, review all outputs to ensure that the profile is correct.

Conversations products are only available in the new Twilio Console(link takes you to an external page). If your account hasn't been migrated, you'll be redirected to the legacy Console where these products won't appear.

Overview

overview page anchor

Tag description

Endpoints


GET/v1/Stores/{storeId}/Profiles/{profileId}/Traits

Base url: https://memory.twilio.com (base url)

Return a paginated, optionally filtered list of individual traits for a profile (flattened view). This is useful for UIs or tools that need to browse trait metadata (names, groups, timestamps). Use the optional traitGroups filter to scope results and the paging parameters to iterate through larger sets.

Request

list-profile-traits-request page anchor

Path parameters

list-profile-traits-path-parameters page anchor
Property nameTypeRequiredPIIDescription
storeIdstring
required
Not PII

A unique Memory Store ID using Twilio Type ID (TTID) format

Example: mem_store_00000000000000000000000000Pattern: ^mem_(store|service)_[0-7][0-9a-z]{25}$

profileIdstring
required

The unique identifier for the profile using Twilio Type ID (TTID) format.

Example: mem_profile_00000000000000000000000000Pattern: ^mem_profile_[0-7][0-9a-z]{25}$
Property nameTypeRequiredPIIDescription
pageSizeinteger

Optional

The maximum number of items to return per page, maximum of 1000.

Default: 50Minimum: 1Maximum: 1000

pageTokenstring

Optional

The token for the page of results to retrieve.

Max length: 500

orderByenum<string>

Optional

Either 'ASC' or 'DESC' to sort results ascending or descending respectively.

Default: DESCPossible values:
ASCDESC

traitGroupsstring

Optional

Comma separated list of trait group names to include.

Example: ContactMin length: 1Max length: 256
200301400401403404429500503

A list of traits.

SchemaExample
Property nameTypeRequiredPIIDescriptionChild properties
traitsarray[Full Trait]

Optional

Max items: 100

metaobject

Optional

Max properties: 4
List Profile TraitsLink to code sample: List Profile Traits
1
// Download the helper library from https://www.twilio.com/docs/node/install
2
const twilio = require("twilio"); // Or, for ESM: import twilio from "twilio";
3
4
// Find your Account SID and Auth Token at twilio.com/console
5
// and set the environment variables. See http://twil.io/secure
6
const accountSid = process.env.TWILIO_ACCOUNT_SID;
7
const authToken = process.env.TWILIO_AUTH_TOKEN;
8
const client = twilio(accountSid, authToken);
9
10
async function listProfileTraits() {
11
const traits = await client.memory.v1
12
.traits(
13
"mem_store_00000000000000000000000000",
14
"mem_profile_00000000000000000000000000"
15
)
16
.list({
17
orderBy: "DESC",
18
limit: 20,
19
});
20
21
traits.forEach((t) => console.log(t.name));
22
}
23
24
listProfileTraits();

Response

Note about this response
1
{
2
"traits": [
3
{
4
"name": "firstName",
5
"value": "Alyssa",
6
"traitGroup": "Contact",
7
"timestamp": "2025-01-01T12:00:00Z"
8
},
9
{
10
"name": "lastName",
11
"value": "Mock",
12
"traitGroup": "Contact",
13
"timestamp": "2025-01-01T12:00:00Z"
14
},
15
{
16
"name": "tier",
17
"value": "gold",
18
"traitGroup": "Loyalty",
19
"timestamp": "2025-01-01T12:30:00Z"
20
},
21
{
22
"name": "points",
23
"value": "1250",
24
"traitGroup": "Loyalty",
25
"timestamp": "2025-01-01T12:30:00Z"
26
}
27
],
28
"meta": {
29
"pageSize": 4,
30
"key": "traits"
31
}
32
}